#pragma once

#include <map>
#include <memory>
#include <vector>

#include "input.h"
#include "camera.h"
#include "scene.h"
#include "texture.h"
#include "fonts.h"
#include "ui.h"
#include "player.h"

namespace kek {

struct PhysicsData;
struct UIData;
struct InputData;

struct KekData {
	GLFWwindow *window;
	Shader *shader;

	Camera *activeCamera;
	Scene *activeScene;

	Player *player;

	int screenWidth;
	int screenHeight;

	float lastFrameTime;

	std::map<std::string, std::weak_ptr<Texture>> loadedTextures;

	FT_Library freetype;

	UIData *ui;
	PhysicsData *physics;
	InputData *input;
};

extern KekData kekData;

}
